--- vcd-0.7/i18n.c	2005-01-26 22:10:45.000000000 +0100
+++ vcd-0.7/i18n.c.modified	2006-12-03 14:04:24.000000000 +0100
@@ -15,212 +15,213 @@
 const tI18nPhrase Phrases[] = {
   { "VideoCD",
     "VideoCD",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "VideoCD", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Tracks",
     "Tracks",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "?cie?ka", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "VideoCD SPI",
     "VideoCD SPI",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "VideoCD SPI", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "SPI",
     "SPI",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "SPI", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "No disc inserted",
     "Keine CD eingelegt",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Brak dysku", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "No VideoCD detected",
     "Keine VideoCD erkannt",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Nie wykryto VideoCD", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "VCD",
     "VCD",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "VCD", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Drive speed",
     "Laufwerkgeschwindigkeit",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Pr?dko?? nap?du", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Broken mode",
     "Nicht standardkonform",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Hide main menu entry",
     "Hauptmen?eintrag ausblenden",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Ukryj wpis w g??wnym menu", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Play tracks continuously",
     "Tracks nacheinander abspielen",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Odtwarzaj ?cie?ki w spos?b ci?g?y", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Autostart replay",
     "Wiedergabe automatisch starten",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Odtwarzaj ?cie?k? Autostart", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { "Setup.VCD$Play sequence replay",
     "Wiedergabe nach Sequenz",
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
-    "", // TODO
+    "", // Slovenski
+    "", // Italiano
+    "", // Nederlands
+    "", // Portugues
+    "", // Francais
+    "", // Norsk
+    "", // suomi
+    "Odtw?rz sekwencj? ponownie", // Polski
+    "", // Espanol
+    "", // Greek
+    "", // Svenska
+    "", // Romana
+    "", // Magyar
   },
   { NULL }
   };
 
+// Strings for Play and Eject missing here.