diff -bBurN skinenigmang-0.1.0/enigma.c skinenigmang-0.1.0-corners/enigma.c
--- skinenigmang-0.1.0/enigma.c	2009-04-24 14:32:08.000000000 +0200
+++ skinenigmang-0.1.0-corners/enigma.c	2009-05-02 09:03:45.000000000 +0200
@@ -240,7 +240,7 @@
 #define SmallGap 2
 #define Gap 4
 #define BigGap 8
-#define Roundness 10
+#define Roundness 0
 
 #define TitleDecoGap SmallGap
 #define TitleDecoGap2 SmallGap
@@ -480,12 +480,12 @@
                      yTitleDecoBottom - 1, Theme.Color(clrTitleBg));
   if (fWithInfo) {
     // draw rounded left corner of title bar
-    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
-                     yTitleTop + Roundness - 1, clrTransparent, -2);
+//    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
+//                     yTitleTop + Roundness - 1, clrTransparent, -2);
   }
   // draw rounded right corner of title bar
-  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1,
-                   yTitleTop + Roundness - 1, clrTransparent, -1);
+//  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1,
+//                   yTitleTop + Roundness - 1, clrTransparent, -1);
   if (fWithInfo) {
     // draw current event area
     osd->DrawRectangle(xEventNowLeft, yEventNowTop, xEventNowRight - 1,
@@ -501,12 +501,12 @@
   osd->DrawRectangle(xBottomLeft, yBottomTop, xBottomRight - 1,
                      yBottomBottom - 1, Theme.Color(clrBottomBg));
   if (fWithInfo) {
-    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
-                     xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent,
-                     -3);
+//    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
+//                     xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent,
+//                     -3);
   }
-  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
-                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
+//  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
+//                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
 }
 
 void cSkinEnigmaDisplayChannel::DrawGroupInfo(const cChannel *Channel, int /* Number */)
@@ -1406,7 +1406,7 @@
   osd->DrawRectangle(xTitleLeft, yTitleBottom, xTitleRight - 1, yTitleDecoTop - 1, clrTransparent);
   osd->DrawRectangle(xTitleLeft, yTitleDecoTop, xTitleRight - 1, yTitleDecoBottom - 1, Theme.Color(clrTitleBg));
   // draw rounded left corner of title bar
-  osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
+//  osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
   idTitle = TE_MARQUEE(osd, idTitle, fScrollTitle, xTitleLeft + Roundness, yTitleTop + (yTitleBottom - yTitleTop - pFontOsdTitle->Height()) / 2, strTitle, Theme.Color(clrTitleFg), Theme.Color(clrTitleBg), pFontOsdTitle, nBPP, xTitleRight - xTitleLeft - Roundness - 1);
 
   // draw date area
@@ -1776,7 +1776,7 @@
                   yButtonsBottom - yButtonsTop, taCenter);
   else {
     osd->DrawRectangle(t0, yButtonsTop, Green ? t1 - 1 : t1, yButtonsBottom - 1, Theme.Color(clrBottomBg));
-    osd->DrawEllipse(t0, yButtonsBottom - Roundness, t0 + Roundness - 1, yButtonsBottom - 1, clrTransparent, -3);
+//    osd->DrawEllipse(t0, yButtonsBottom - Roundness, t0 + Roundness - 1, yButtonsBottom - 1, clrTransparent, -3);
   }
   if (Green)
     osd->DrawText(t1, yButtonsTop, Green, Theme.Color(clrButtonGreenFg),
@@ -1797,8 +1797,8 @@
                   yButtonsBottom - yButtonsTop, taCenter);
   else {
     osd->DrawRectangle(t3, yButtonsTop, xButtonsRight, yButtonsBottom, Theme.Color(clrBottomBg));
-    osd->DrawEllipse(xButtonsRight - Roundness, yButtonsBottom - Roundness,
-                     xButtonsRight - 1, yButtonsBottom - 1, clrTransparent, -4);
+//    osd->DrawEllipse(xButtonsRight - Roundness, yButtonsBottom - Roundness,
+//                     xButtonsRight - 1, yButtonsBottom - 1, clrTransparent, -4);
   }
   if (fLockNeeded && !fLocked) TE_UNLOCK;
 }
@@ -1922,7 +1922,7 @@
 
   osd->DrawRectangle(xBodyLeft, y, xItemLeft - 1, y + lineHeight - 1, ColorBg);
   if (EnigmaConfig.showMarker) {
-    osd->DrawEllipse(xBodyLeft + nMarkerGap, y + nMarkerGap, xBodyLeft + lineHeight - nMarkerGap, y + lineHeight - nMarkerGap, isCurrent ? ColorFg : ColorBg);
+//    osd->DrawEllipse(xBodyLeft + nMarkerGap, y + nMarkerGap, xBodyLeft + lineHeight - nMarkerGap, y + lineHeight - nMarkerGap, isCurrent ? ColorFg : ColorBg);
   }
 
   if (EnigmaConfig.showScrollbar == 0 || (!fScrollbarShown && EnigmaConfig.showScrollbar == 2))
@@ -2855,10 +2855,10 @@
     // draw title area
     osd->DrawRectangle(xTitleLeft, yTitleTop, xTitleRight - 1,
                        yTitleBottom - 1, Theme.Color(clrTitleBg));
-    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
-                     yTitleTop + Roundness - 1, clrTransparent, -2);
-    osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight,
-                     yTitleTop + Roundness, clrTransparent, -1);
+//    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
+//                     yTitleTop + Roundness - 1, clrTransparent, -2);
+//    osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight,
+//                     yTitleTop + Roundness, clrTransparent, -1);
     osd->DrawRectangle(xTitleLeft, yTitleDecoTop, xTitleRight - 1,
                        yTitleDecoBottom - 1, Theme.Color(clrTitleBg));
     // draw logo area
@@ -2872,11 +2872,11 @@
     // draw bottom area
     osd->DrawRectangle(xBottomLeft, yBottomTop, xBottomRight - 1,
                        yBottomBottom - 1, Theme.Color(clrBottomBg));
-    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
-                     xBottomLeft + Roundness - 1, yBottomBottom - 1,
-                     clrTransparent, -3);
-    osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
-                     xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
+//    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
+//                     xBottomLeft + Roundness - 1, yBottomBottom - 1,
+//                     clrTransparent, -3);
+//    osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
+//                     xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
 
     xFirstSymbol = DrawStatusSymbols(0, xFirstSymbol, yBottomTop, yBottomBottom) - Gap;
   }
@@ -2917,7 +2917,7 @@
 
   if (modeonly) {
     osd->DrawRectangle(xLogoLeft, yLogoTop, xLogoRight - 1, yLogoBottom - 1, clrTransparent);
-    osd->DrawEllipse(xLogoLeft, yLogoTop, xLogoRight - 1, yLogoBottom - 1, Theme.Color(clrLogoBg));
+//    osd->DrawEllipse(xLogoLeft, yLogoTop, xLogoRight - 1, yLogoBottom - 1, Theme.Color(clrLogoBg));
   } else {
     osd->DrawRectangle(xLogoLeft, yLogoTop, xLogoRight - 1, yLogoBottom - 1, Theme.Color(clrLogoBg));
     osd->DrawRectangle(xLogoDecoLeft, yLogoTop, xLogoDecoRight - 1, yLogoBottom - 1, Theme.Color(clrLogoBg));
@@ -3212,16 +3212,16 @@
   // draw title
   osd->DrawRectangle(xTitleLeft, yTitleTop, xTitleRight - 1, yTitleBottom - 1, Theme.Color(clrTitleBg));
   osd->DrawRectangle(xTitleLeft, yTitleDecoTop, xTitleRight - 1, yTitleDecoBottom - 1, Theme.Color(clrTitleBg));
-  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1, yTitleTop + Roundness - 1, clrTransparent, -1);
+//  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1, yTitleTop + Roundness - 1, clrTransparent, -1);
   // draw body area
   osd->DrawRectangle(xBodyLeft, yBodyTop, xBodyRight - 1, yBodyBottom - 1, Theme.Color(clrBackground));
   // draw bottom area
   osd->DrawRectangle(xBottomLeft, yBottomTop, xBottomRight - 1, yBottomBottom - 1, Theme.Color(clrBottomBg));
-  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness, xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
+//  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness, xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
 
   if (!fShowSymbol) {
-    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
-    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness, xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent, -3);
+//    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
+//    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness, xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent, -3);
   }
 }
 
@@ -3424,11 +3424,11 @@
                 xTitleRight - Roundness - xTitleLeft - Roundness, yTitleBottom - yTitleTop,
                 fShowSymbol ? taCenter : taLeft);
   // draw rounded left corner of titlebar
-  osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
-                   yTitleTop + Roundness - 1, clrTransparent, -2);
+//  osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1,
+//                   yTitleTop + Roundness - 1, clrTransparent, -2);
   // draw rounded right corner of titlebar
-  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1,
-                   yTitleTop + Roundness - 1, clrTransparent, -1);
+//  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1,
+//                   yTitleTop + Roundness - 1, clrTransparent, -1);
   if (fShowSymbol) {
     // draw logo area
     osd->DrawRectangle(xLogoLeft, yLogoTop, xLogoRight - 1, yLogoBottom - 1, Theme.Color(clrLogoBg));
@@ -3438,10 +3438,10 @@
   osd->DrawRectangle(xListLeft, yListTop, xListRight - 1, yListBottom - 1, Theme.Color(clrBackground));
   // draw bottom
   osd->DrawRectangle(xBottomLeft, yBottomTop, xBottomRight - 1, yBottomBottom - 1, Theme.Color(clrBottomBg));
-  osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
-                   xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent, -3);
-  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
-                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
+//  osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
+//                   xBottomLeft + Roundness, yBottomBottom - 1, clrTransparent, -3);
+//  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
+//                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
   // fill up audio tracks
   for (int i = 0; i < NumTracks; i++)
     SetItem(Tracks[i], i, false);
@@ -3474,10 +3474,10 @@
   // draw track id
   osd->DrawRectangle(xListLeft, y, xListRight, y + lineHeight, ColorBg);
   if (EnigmaConfig.showMarker) {
-    osd->DrawEllipse(xListLeft + nMarkerGap, y + nMarkerGap,
-                     xListLeft + lineHeight - nMarkerGap,
-                     y + lineHeight - nMarkerGap,
-                     isCurrent ? ColorFg : ColorBg);
+//    osd->DrawEllipse(xListLeft + nMarkerGap, y + nMarkerGap,
+//                     xListLeft + lineHeight - nMarkerGap,
+//                     y + lineHeight - nMarkerGap,
+//                     Current ? ColorFg : ColorBg);
   }
   osd->DrawText(xItemLeft, y, Text, ColorFg, ColorBg, pFontListItem, xItemRight - xItemLeft, lineHeight);
   osd->DrawRectangle(xItemRight, y, xListRight - 1, y + lineHeight - 1, ColorBg);
@@ -3661,7 +3661,7 @@
   // draw title
   osd->DrawRectangle(xTitleLeft, yTitleTop, xTitleRight - 1, yTitleBottom - 1, Theme.Color(clrTitleBg));
   osd->DrawRectangle(xTitleLeft, yTitleDecoTop, xTitleRight - 1, yTitleDecoBottom - 1, Theme.Color(clrTitleBg));
-  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1, yTitleTop + Roundness - 1, clrTransparent, -1);
+//  osd->DrawEllipse(xTitleRight - Roundness, yTitleTop, xTitleRight - 1, yTitleTop + Roundness - 1, clrTransparent, -1);
   // draw centered message text
   osd->DrawRectangle(xMessageLeft, yMessageTop, xMessageRight - 1, yMessageBottom - 1, clrTransparent);
   osd->DrawRectangle(xMessageLeft, yMessageTop, xMessageRight - 1,
@@ -3674,14 +3674,14 @@
                          yMessageBottom - 2 * SmallGap - yMessageTop - 2 * SmallGap, taCenter);
   // draw bottom
   osd->DrawRectangle(xBottomLeft, yBottomTop, xBottomRight - 1, yBottomBottom - 1, Theme.Color(clrBottomBg));
-  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
-                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
+//  osd->DrawEllipse(xBottomRight - Roundness, yBottomBottom - Roundness,
+//                   xBottomRight - 1, yBottomBottom - 1, clrTransparent, -4);
 
   if (!(fShowSymbol)) {
     // draw ellipse if not showing logo
-    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
-    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
-                     xBottomLeft + Roundness - 1, yBottomBottom - 1, clrTransparent, -3);
+//    osd->DrawEllipse(xTitleLeft, yTitleTop, xTitleLeft + Roundness - 1, yTitleTop + Roundness - 1, clrTransparent, -2);
+//    osd->DrawEllipse(xBottomLeft, yBottomBottom - Roundness,
+//                     xBottomLeft + Roundness - 1, yBottomBottom - 1, clrTransparent, -3);
   }
   if (fLockNeeded && !fLocked)
     TE_UNLOCK;